#!/usr/dist/pkgs/perl,v5.003/5bin.sun4/perl

require 5.003;
BEGIN {
    my($workdir) = ($0 =~ /(.*)\/.*/);
    unshift(@INC,"$workdir/../lib");
}
my($workdir) = ($0 =~ /(.*)\/.*/);
use BER;
use SNMP_Session;
use SNMP_MIB;
use SNMP_Simple;
use Socket;
use strict;

### MAIN ###

sub byOID {
    my(@oida) = split(/\./, $a);
    my(@oidb) = split(/\./, $b);
    my($vala, $valb);
    do {
	$vala = shift @oida;
	$valb = shift @oidb;
	my $tmpval = int($vala) <=> int($valb);
    } while ((int($vala) == int($valb)) && scalar @oida && scalar @oidb);
    return $vala <=> $valb if ((@oida == 0) && (@oidb == 0));
    return -1 if (@oida == 0);
    return 1 if (@oidb == 0);
    return int($vala) <=> int($valb);
}

my($community) = "public";

SNMP_MIB::loadoids("$workdir/../mibs", "IPMROUTE");

my ($host) = $ARGV[0];
my @hostip = gethostbyname($host);
$hostip[0] = inet_aton($hostip[0]);
my ($aip,$bip,$cip,$dip) = unpack('C4',$hostip[0]);
$host = "$aip.$bip.$cip.$dip";
my $ping = system("/usr/sbin/ping $host 2 > /dev/null 2>&1");
if ($ping == 0) {
    my $session = SNMP_Simple->open ($host, $community, 161);
    $session->{'retries'} = 1;
    my ($router) = $session->snmpget('ipMRouteEnable');
    if (defined($router) && ($router == 1)) {
	my %mroutes= $session->snmpgettableka(12, 'ipMRoutePkts', 'ipMRouteDifferentInIfPackets');
	my ($routeid, $group, $source, $pkts, $rpffail);
	my %sources;

format DATA =
@<<<<<<<<<<<<<<< @<<<<<<<<<<<<<<< @<<<< @<<<<
$source, $group, $pkts, $rpffail
.

$~ = "DATA";
	foreach $routeid (sort byOID keys %mroutes) {
	    my ($g1, $g2, $g3, $g4, $s1, $s2, $s3, $s4, $m1, $m2, $m3, $m4) =
		split(/\./, $routeid, 12);
	    $group = "$g1.$g2.$g3.$g4";
	    $source = "$s1.$s2.$s3.$s4";
            $pkts = $mroutes{$routeid}->{'ipMRoutePkts'};
            $rpffail = $mroutes{$routeid}->{'ipMRouteDifferentInIfPackets'};
	    $sources{"$source.$group"} = "$source $group $pkts $rpffail";
	}
        
        foreach $routeid (sort byOID keys %sources) {
	    ($source, $group, $pkts, $rpffail) = split(' ', $sources{$routeid});
            write;
	}
    } else {
	print "$host is not a multicast router.\n";
    }
    $session->close();
} else {
    print "$host is unreachable.\n";
}

exit 0;
