#!/usr/dist/pkgs/perl,v5.003/5bin.sun4/perl
require 5.003;

BEGIN {
    ($workdir) = ($0 =~ /(.*)\/.*/);
}
use lib "$workdir/../lib";
my ($workdir) = ($0 =~ /(.*)\/.*/);
use Socket;
use SNMP_MIB;
use SNMP_Simple;
use strict;

my $community = $ARGV[0];

my ($hostname);
SNMP_MIB::loadoids("$workdir/../mibs", "RFC1213", "CISCO-STACK");
foreach $hostname (<STDIN>) {
    chomp $hostname;
    next unless defined gethostbyname($hostname);
    my($session) = SNMP_Simple->open($hostname, $community);
    
    next unless defined $session;
    my ($sysObjectID) = $session->snmpget('sysObjectID');
    if (defined $sysObjectID) {
	my $cisco_switch_sysid = '1\.3\.6\.1\.4\.1\.9\.5';
	my $filename = undef;
	my $module = undef;
	my $sup = undef;

	if (!($sysObjectID =~ /^$cisco_switch_sysid/)) {
	    print "$hostname: Can't upgrade this type of device - $sysObjectID.\n";
	    next;
	}
	
	my %modules = $session->snmpgettableka(1, 'moduleType');
	foreach $module (sort {$a <=> $b} keys %modules) {
	    my $moduleType = $modules{$module}->{'moduleType'};
	    if (($moduleType == 23) 
		|| (($moduleType >= 38) && ($moduleType <= 42))) { #Sup1/2
		$filename = "cat5000-sup8m.3-2-2.bin";
		$sup = $module;
		last;
	    } elsif (($moduleType == 57) #Sup III
		     || ($moduleType == 91)
		     || ($moduleType == 92) ) {
		$filename = "cat5000-sup3.4-5-1.bin";
		$sup = $module;
		last;
	    } elsif (($moduleType == 200)) { #Cat6k
		$filename = "cat6000-sup.5-2-1-CSX.bin";
		$sup = $module;
		last;
	    }
	}

	if (defined($filename)) {
	    if ($session->snmpset('tftpHost', 'string', '129.150.77.6')) {
		if ($session->snmpset('tftpFile', 'string', $filename)) {
		    if ($session->snmpset('tftpModule', 'int', $sup)) {
			if ($session->snmpset('tftpAction', 'int', 5)) {
			    my ($result) = $session->snmpget('tftpResult');
			    if ($result == 1 || $result == 2) {
				print "$hostname: starting upgrade.\n";
			    } else {
				print "$hostname: Bad TFTP result - $result\n";
			    }
			} else {
			    print "$hostname: Error initating upgrade.\n";
			}
		    } else {
			print "$hostname: Error setting load module.\n";
		    }
		} else {
		    print "$hostname: Error on SNMP set of load file.\n";
		}
	    } else {
		print "$hostname: Error on SNMP set of server address.\n";
	    }
	} else {
	    print "$hostname: did not find a supervisor module.";
	} 
    } else {
	print "$hostname: No SNMP response.\n";
    }
    $session->close();
}
exit 0;
